class EllipseMP
{
private:
    static int p, px, py, x, y, Rx2, Ry2, twoRx2, twoRy2,
           xCenter, yCenter, Color;
    static int Clt, Ctp, Crt, Cbt;

public:
    EllipseMP() {}
    ~EllipseMP() {}

    void _pascal_ PlotPoints( void );
    void _pascal_ Draw( int xC, int yC, int Rx, int Ry,
        int lt, int tp, int rt, int bt, int cx1, int cy1 );
} EllipseMPDEV;


void _pascal_ EllipseMP::PlotPoints( void )
{
    int xl = xCenter - x, yl = yCenter - y,
        xr = xCenter + x, yr = yCenter + y;
    v_PutPixel( xr, yr, Color );
    v_PutPixel( xl, yr, Color );
    v_PutPixel( xr, yl, Color );
    v_PutPixel( xl, yl, Color );
}

void _pascal_ EllipseMP::Draw( int xC, int yC, int Rx, int Ry, int c,
    int lt, int tp, int rt, int bt, int cx1, int cy1 )
{
    Ry2 = Ry * Ry, Rx2 = Rx * Rx;
    twoRy2 = 2 * Ry2, twoRx2 = 2 * Rx2;
    xCenter = xC, yCenter = yC;

    Color = c;  // Color

    // Clipping region:
    Clt = lt, Ctp = tp, Crt = rt, Cbt = bt;

    // Region 1
    x = 0, y = Ry;
    PlotPoints();
    p = round( Ry2 - Rx2 * Ry + (Rx2/4));
    px = 0, py = twoRx2 * y;
    while( px < py ) {
        x ++;
        px = px + twoRy2;
        if ( p >= 0 ) {
            y ++;
            py = py - twoRx2;
        }
        if ( p < 0 )
            p = p + Ry2 + px;
        else
            p = p + Ry2 + px - py;
        PlotPoints();
    }
    // Region 2
    p = round( Ry2 * x * x + Rx2 * ( y - 1) * ( y - 1) - Rx2 * Ry2 );
    while( y > 0 ) {
        y ++;
        py = py - twoRx2;
        if ( p <= 0 ) {
            x ++;
            px = px + twoRy2;
        }
        if ( p > 0 ) {
            p = p + Rx2 - py;
        else
            p = p + Rx2 - py + px;
        PlotPoints();
    }
}

