#include "xbmtools.h"
#include "macros.h"
#include "buffer.h"
#include <string.h>

#define bmBuf buffer


#define MyLBMGetPix(x,y,lbitmap)  \
    (lbitmap[(x) + (y) * SrcWid])

int EnlargeBitmap( char _FAR_ *SrcBmp, char _FAR_ *DestBmp, int size )
{
    if ( size < 2 ) return 0;
    BYTE pix;
    int r, c, i, j;
    int SrcWid, SrcHei, DestWid, DestHei;

    SrcWid = (int)LBMWidth(SrcBmp);
    SrcHei = (int)LBMHeight(SrcBmp);
    DestWid = SrcWid * size;
    DestHei = SrcHei * size;
    if ( DestWid > 255 || DestHei > 255 ) return 0;

    LBMWidth(DestBmp)  = (BYTE)DestWid;
    LBMHeight(DestBmp) = (BYTE)DestHei;
    SrcBmp += 2;
    DestBmp += 2;

    char _FAR_ *BufPtr;
    for( r = 0; r < SrcHei; r ++ ) {
        BufPtr = DestBmp;
        for( c = 0; c < SrcWid; c ++ ) {
            for( i = 0; i < size; i++ ) {
                *DestBmp = *SrcBmp;
                DestBmp ++;
            }
            SrcBmp ++;
        }
        for( i = 1; i < size; i ++ ) {
            memcpy( DestBmp, BufPtr, DestWid );
            DestBmp += DestWid;
        }
    }
    return size;
}

