#ifndef _INIFILE_H_
#define _INIFILE_H_

#ifndef _pascal_
#define _pascal_ _pascal
#endif

#define INI_NO_ERROR        0
#define INI_SYNTAX_ERROR    1
#define INI_TYPE_ERROR      2
#define INI_NOT_FOUND_ERROR 3
#define INI_NO_FILE_ERROR   4
#define INI_NO_VALUE_ERROR  5
#define INI_NO_BUF_ERROR    6
#define INI_LOCK_ERROR      7


class zINIFile {
protected:
    char *buf;
    FILE *fp;
    long int SectionLock;
    int Error;
    int _pascal_ FindString( char *str, int item = 0 );
    char *_pascal_ StringValue( char c );
public:
    _pascal_ zINIFile( char *fn = 0 )
        :fp(0), SectionLock(0), buf(0), Error(0) { Open( fn ); }
    _pascal_ ~zINIFile() { Close(); }
    int _pascal_ FindItem( char *ItemName, long int &Value );
    int _pascal_ FindItem( char *ItemName, char *Value );
    int _pascal_ FindSection( char *SectName );
    void _pascal_ SetWorkBuf( char *bufPtr ) { buf = bufPtr; }
    int _pascal_ ErrorNo( void ) { return Error; }
    int _pascal_ Open( char *fn );
    int _pascal_ Close( void );
};

#endif
