#include "macros.h"
#include "vidinter.h"

char _FAR_ RawPalData[768];
char _FAR_ *RawPalPtr = 0;
char _FAR_ *FontDataPtr = 0;
int DefColors[9];  // system colors(default: color index 1-12)
int RGBColors[3];   // RGB colors 10-12
// colors 13-15 for other uses
// colors 16-239   // 224 colors User colors
// colors 240-255  // 16 Special colors (pallete rotate, special effects.)

BBOOL PageFlipping = FALSE;

//
// Include the appropriate source code here
#ifdef __XLIB__
#include "xlib\xlibintr.cpp"
#endif

#ifdef __MODE13H__
#include "mode13\mode13.cpp"
#endif

#ifdef __TURBOC_GRAPH__
#include "tbbgi\tbgraph.cpp"
#endif

#ifdef __LINUX__
#include "linux\lnxmode.cc"
#endif

#define RECT( x, y, l, h ) ( x, y, x + l, y + h )

