#ifndef _CHKBOX_H_
#define _CHKBOX_H_
#include "classes.h"
#include "macros.h"
#include "object.h"
#include "vidinter.h"
#include "actids.h"
#include "depend.h"

class CheckBox:public ScrObj {

protected:
    BBOOL on;

public:
     _pascal_ CheckBox( int x1, int y1, int x2, int y2, WORD id = 0 )
        :ScrObj( x1, y1, x2, y2, CChkBoxHand, id ),on(FALSE) {}
     _pascal_ ~CheckBox() {}

    void _pascal_ CDrawChk( int = HighLiteColor ); // draw a check if on
    BBOOL _pascal_ CStatus( void )  { return on; }
    void  _pascal_ CToggle( void )  { on = !on; CShowObject(); }
    virtual void  _pascal_ CShowObject( void );
    virtual void  _pascal_ CUpdate( BBOOL = FALSE );
    virtual int   _pascal_ identify( void ) { return CHKBOX_ID; }
	static DeclareObjH( CChkBoxHand );
    virtual int  _pascal_ CSetDefaultHand( void )
    {
        CSetHandler( CChkBoxHand );
        return 1;
    }
};

inline void  _pascal_ CheckBox::CUpdate( BBOOL value )
{
    on = value;
    CShowObject();
}

#endif
