#ifndef _SAVESIZE_H_
#define _SAVESIZE_H_

#define GET_SAVE_SIZE       4001
#define GET_SPR_WH          4001
#define CONFIRM_GET_SIZE    4003
#define CANCEL_GET_SIZE     4004
#define CONFIRM_SPR_WH      4003
#define CANCEL_SPR_WH       4004

void _pascal_ GetWH( Object *Caller, int SendId,
                     int *w, int *h, int MaxW = 64, int MaxH = 64,
                     char *Title = 0 );
void _pascal_ GetSaveSize( Object *Caller,  // Who called?
        int SendID,      // What do you want? (only one option! defined above)
        ScrObj *Canvas,  // Canvas object to select part of a sprite
        ScrObj *Viewer,  // Object to view the selected part
        char _FAR_ *SprData,  // Sprite to select from
        char _FAR_ *ReceiveData,  // Allocated mem to receive selected area
                                  // Make sure allocated enough memory for
                                  // the whole sprite. i.e. as big as the
                                  // SprData has
        int *x1, int *y1,   // Initial upper corner of the area (1,1) min
        int *w, int *h,     // Width of the initial area
        int MaxW = 64,      // Maximum width of the area
        int MaxH = 64,      // Maximum height of the area
        char *Title = 0  ); // Title String ( 0 => use default )

#endif
