#ifndef _SPRVIEWER_H_
#define _SPRVIEWER_H_

class zSprView;
class zCanvas;
class CRL;

class zSprView:public ScrObj
{
public:
    int Width, Height, PixSize, Idx, OrigX, OrigY;
    int vX1, vY1, vX2, vY2;
    ScrObj *IndicObj;
    char _FAR_ *data;
    zCanvas *myCanvas;
    char Name[MAXFILE+MAXEXT];


    _pascal_ zSprView( int x1, int y1, int x2, int y2,
                       OBJH h = 0, WORD id = 0 )
        :ScrObj( x1, y1, x2, y2, h, id ),
        Idx(0), Width(SPR_WIDTH),
        Height(SPR_HEIGHT), myCanvas(0),
        OrigX( x1 + 1), OrigY( y1 + 1),
        PixSize(PIX_SIZE) { Name[0] = 0; }
    _pascal_ ~zSprView() {}

    int  _pascal_ CheckMoveMent( void );
    void _pascal_ SetCanvas( zCanvas &c );
    void _pascal_ SelectViewer( BYTE mouBut );
    void _pascal_ RedrawViewer( void );
    void _pascal_ RedrawVC( void );
    void _pascal_ OutLineSprite( int color = v_cWhite );
    void _pascal_ DoMoveMent( BYTE mouBut, int Move );
    void _pascal_ CopyToBuffer( void );
    void _pascal_ CopyToScreen( void );
    void _pascal_ SetWH( int w, int h );
    void _pascal_ SetNewBuf( char _FAR_ *buf = 0 );
    void _pascal_ FlipHorizontal( void );
    void _pascal_ FlipVertical( void );
    void _pascal_ RotateLeft( void );
    void _pascal_ RotateRight( void );

};

extern zSprView *SprView[4];
DeclareObjH( SpriteView );

#endif
