#include <stdio.h>
#include <dos.h>
#include <conio.h>
extern "C" {
#include <signal.h>
}
#include "interr.h"


unsigned beats;
typedef unsigned char BYTE;

DeclareOldIsr( oldTimerIsr );    // address of old ISR
DeclareNewIsr( newTimerIsr )
{
// the new interrupt function
	beats++;
	oldTimerIsr();              // chain to previous ISR
}


int main(void)
{
	int i, oldbeats = 0, endbeats = 0;
	beats = 0;

	signal(SIGINT,SIG_IGN);  	// ingnore ^C and ^Break
	installisr( oldTimerIsr, newTimerIsr, 0x08 );
	for (i = 100; i <= 500; i += 100 ) {
		oldbeats = beats;
		delay( i );
		endbeats = beats;
		printf("delay: %4d ms  start beats: %5d  end beats: %5d  diff: %3d\n",
				i, oldbeats, endbeats, endbeats - oldbeats );
	}
	removeisr( 0x08, oldTimerIsr ); // remove interrupt handler
	return 0;
}
