#ifndef _QUEUE_H_
#define _QUEUE_H_

#define Q_CACHE_LIMIT 30

class qItem
{
private:
	int   item;
	qItem *next;
	static char* cachePool;
	static qItem* Cache[ Q_CACHE_LIMIT ];
	static int nCache;
	static int i;
public:
	qItem( int value ):item( value), next(0) {}
	void* operator new( size_t );
	void operator delete( void *ptr, size_t );
	friend class queue;
};

class queue
{
private:
	qItem *head;
	qItem *tail;
	int   Total;
public:
	queue(): head(0), tail(0), Total(0) { }
	~queue();
	int CAdd( int value );
	int CGet( void );
	int  CGetTotal() { return Total; }
};

#endif