///////////////////
#ifndef _CONFIG_H_
#define _CONFIG_H_
///////////////////

#define DOUBLE_BUF      1       // Will use double buffer if non-zero
#define DBF_PAGEFLIP    1       // Will be flip pages constantly
#define DOUBLE_CLICK    0       // Time double clicks
#define USE_TIMER       1       // Use to timer
#define NORMAL_TIMER    0       // Won't use speeded up timer if non-zero
#define AUTO_MOUSE      0       // Automatically draw mouse cursor each loop
#define TRACE_MOUSE     1
#define TRACE_BORDER    0

//////////////////////////
// 3-d outlined buttons //
//////////////////////////

// button will use 3d outline if defined (button will be bigger)
// Each button will need to reserve 2 lines for the outline
// NOTE: It is recommended to change this definition in the file
// "button.cpp" since this will only affect that file.  Chaning
// the file "config.h" will recompile almost every file.
#define OUTLINE_3D


///////////////////////////////////////////
// Compile under Which Operating System  //
///////////////////////////////////////////

//#define __LINUX__       0       // Use Linux

// The program is compile for msdos if not compile for linux
#ifndef __LINUX__
#ifndef __MSDOS__
#define __MSDOS__
#endif
#endif


///////////////////////////////////////
// Compile using which graphic lib   //
// Only has effect for msdos now     //
///////////////////////////////////////

#ifdef __MSDOS__

#define __XLIB__        1       // Use XLIB Graphic library

// Compile using MODE-13 VGL library otherwise
// Only work for small memory model :(
// because VGL doesn't support larger ones
// #define __MODE13H__

// Compile using Turbo-C's graph library
// #define __TURBOC_GRAPH__

#endif


///////
#endif
///////
/* End of file config.h */
