///////////////////
#ifndef _CONFIG_H_
#define _CONFIG_H_
///////////////////

//////////////////////////
// 3-d outlined buttons //
//////////////////////////

// button will use 3d outline if defined (button will be bigger)
// Each button will need to reserve 2 lines for the outline
// NOTE: It is recommended to change this definition in the file
// "button.cpp" since this will only affect that file.  Chaning
// the file "config.h" will recompile almost every file.
#define OUTLINE_3D


///////////////////////////////////////////
// Compile under Which Operating System  //
///////////////////////////////////////////

// The program is compile for linux if defined
// #define __LINUX__

// The program is compile for msdos if not compile for linux
#ifndef __LINUX__
#ifndef __MSDOS__
#define __MSDOS__
#endif
#endif


///////////////////////////////////////
// Compile using which graphic lib   //
// Only has effect for msdos now     //
///////////////////////////////////////

#ifdef __MSDOS__
// Compile using MODE-X library xlib if defined
#define __XLIB__

// Compile using MODE-13 VGL library otherwise
// Only work for small memory model :(
// because VGL doesn't support larger ones
// #define __MODE13H__

// Compile using Turbo-C's graph library
// #define __TURBOC_GRAPH__

#endif


///////
#endif
///////
/* End of file config.h */
